/******************************************
 * Stop Motion                            *
 * Tutor: Paolo Pasteris                  *
 * progettoMM 11/12 Unimi                 *
 ******************************************/
import codeanticode.gsvideo.*;

GSCapture cam;
PImage img, out;
int count, fps, w, h;
GSMovieMaker mm;

void setup() 
{
  count = 0;
  fps = 8;
  w = 320;
  h = 240;
  size(320,240);
  cam = new GSCapture(this, w, h, "/dev/video0");
  cam.start();
  img = createImage(w, h, RGB);
  out = createImage(w, h, RGB);
  mm = new GSMovieMaker(this, width, height, "stopMotion.ogg",
                       GSMovieMaker.THEORA, GSMovieMaker.HIGH,
                       fps);
  mm.start();
}

void draw() {
  if (cam.available()) {
    cam.read();
    for (int x = 0; x < w; x++) {
      for (int y = 0; y < h; y++) {
        int p1 = cam.get(x,y);
        int p2 = img.get(x,y);
        out.set(x,y,color(red(p1)/2+red(p2)/2,
                      green(p1)/2+green(p2)/2,
                      blue(p1)/2+blue(p2)/2));
      }
    }
    image(out,0,0);
  }
}

void keyPressed() {
  if(key == ESC) {
    mm.finish();
  }
  else {
    out.save("overlayedframe.tif");
    img.copy(cam,0,0,w,h,0,0,w,h);
    mm.addFrame(img.pixels);
    img.save("img-"+String.format("%04d",count)+".tif");
    count++;
  } 
}
